#if defined(__linux__)
#if defined(__amd64__)

/*
 * Use Linux system call.
 */

#define SYS_exit  60
#define SYS_read   0
#define SYS_write  1
#define SYS_open   2
#define SYS_close  3
#define SYS_ioctl 16

	.section .text

	.globl	___exit
	.type	___exit, @function
___exit:
	mov	$SYS_exit, %eax
	syscall
	retq

	.globl	__read
	.type	__read, @function
__read:
	mov	$SYS_read, %eax
	syscall
	retq

	.globl	__write
	.type	__write, @function
__write:
	mov	$SYS_write, %eax
	syscall
	retq

	.globl	__open
	.type	__open, @function
__open:
	mov	$SYS_open, %eax
	syscall
	retq

	.globl	__close
	.type	__close, @function
__close:
	mov	$SYS_close, %eax
	syscall
	retq

	.globl	__ioctl
	.type	__ioctl, @function
__ioctl:
	mov	$SYS_ioctl, %eax
	syscall
	retq
#endif
#endif
